package rocks.zipcode.quiz3a.objectorientation.bankaccount;

import org.junit.Assert;
import org.junit.Test;
import rocks.zipcode.quiz3a.objectorientation.account.BankAccount;

/**
 * @author leon on 30/12/2018.
 */
public class WithdrawalTest {
    @Test
    public void test1() {
        test(100.0, 80.0);
    }

    @Test
    public void test2() {
        test(150.0, 70.0);
    }

    @Test(expected = IllegalArgumentException.class)
    public void test3() {
        test(100.0, 180.0);
    }

    @Test(expected = IllegalArgumentException.class)
    public void test4() {
        test(10.0, 50.0);
    }

    public void test(Double initialBalance, Double withdrawalAmount) {
        // given
        Double expected = initialBalance - withdrawalAmount;
        BankAccount bankAccount = new BankAccount();
        bankAccount.setBalance(initialBalance);

        // when
        bankAccount.withdrawal(withdrawalAmount);
        Double actual = bankAccount.getBalance();

        // then
        Assert.assertEquals(expected, actual);
    }
}
