package rocks.zipcode.quiz3a.objectorientation.employee;

import org.junit.Assert;
import org.junit.Test;
import rocks.zipcode.quiz3a.objectorientation.account.BankAccount;
import rocks.zipcode.quiz3a.objectorientation.account.Employee;
import rocks.zipcode.quiz3a.objectorientation.account.Transactable;
import rocks.zipcode.quiz3a.objectorientation.account.Worker;

/**
 * @author leon on 30/12/2018.
 */
public class EmployeeConstructorTest {
    @Test
    public void testNullaryConstructor() {
        // given
        Employee employee = new Employee();
        Worker worker = (Worker) employee;
        Transactable transactable = (Transactable) employee;

        Double expectedHourlyWage = 35.0;
        Double expectedHoursWorked = 0.0;
        Double expectedBalance = 0.0;
        Double expectedBankAccountBalance = 0.0;

        Assert.assertNotNull(employee.getBankAccount());
        Assert.assertEquals(expectedHourlyWage, worker.getHourlyWage());
        Assert.assertEquals(expectedHoursWorked, worker.getHoursWorked());
        Assert.assertEquals(expectedBalance, transactable.getBalance());
        Assert.assertEquals(expectedBankAccountBalance, employee.getBankAccount().getBalance());
    }

    @Test
    public void testNonNullaryConstructor() {
        // given
        Double expectedHourlyWage = 35.0;
        Double expectedHoursWorked = 0.0;
        Double expectedBalance = 15.0;
        Double expectedBankAccountBalance = expectedBalance;
        Double expectedMoneyEarned = expectedHourlyWage * expectedHoursWorked;
        BankAccount bankAccount = new BankAccount();
        bankAccount.setBalance(expectedBankAccountBalance);

        // when
        Employee employee = new Employee(bankAccount);
        Worker worker = (Worker) employee;
        Transactable transactable = (Transactable) employee;


        Assert.assertNotNull(employee.getBankAccount());
        Assert.assertEquals(expectedHourlyWage, worker.getHourlyWage());
        Assert.assertEquals(expectedHoursWorked, worker.getHoursWorked());
        Assert.assertEquals(expectedBalance, transactable.getBalance());
        Assert.assertEquals(expectedMoneyEarned, expectedMoneyEarned);
        Assert.assertEquals(expectedBankAccountBalance, employee.getBankAccount().getBalance());
    }

}
